#include <SFML/Graphics.hpp>
#include <iostream>
#include <sstream>
#include <string>
#include "player.h"

extern Player plyr;
extern sf::RenderWindow App;

sf::Image FontImage;
sf::Sprite CharImage;

void InitFont()
{
	FontImage.LoadFromFile("data\\images\\arfont.png");
	FontImage.SetSmooth(false);
	FontImage.CreateMaskFromColor(sf::Color(0, 0, 0));
	CharImage.SetImage(FontImage);
	//CharImage.SetColor(sf::Color(111, 159, 6, 255));

}

void SetFontColour(int r,int g, int b, int a)
{
	CharImage.SetColor(sf::Color(r, g, b, a));
}

void DrawChar(int topY, int x,int y, int initchar_no)
{
	int char_no;
	if ((plyr.scenario==1) || (plyr.scenario==255)) {char_no = initchar_no-32; } // dungeon
	else {char_no = initchar_no+96; } // city
	int row, column;
	int topX = 16; //16
	int charsPerRow = 16; // number of chars per row in font image containing all tiles (16 default)
	int charsPerColumn = 16; // number of chars per column in font image (16 default)
	
	//Select 16x16 section of tile sheet for tile
	
	if ( char_no > charsPerRow)
	{
		column = (char_no % charsPerRow); // remainder
		row = ((char_no-column)/charsPerRow);
	}
	else
	{
		column = char_no;
		row = 0; // = row 1 on the actual font sheet at y=0
	}

	int charX = (column)*16;	// x loc on tiles image in pixels
	int charY = ((row)*16);		// y loc on tiles image in pixels
	//std::cout << "tile:" << tile_no << "row:" << spriteRow << "col:" << spriteColumn << "\n";
	CharImage.SetSubRect(sf::IntRect(charX, charY , (charX+16), (charY+16)));
	if (char_no==16) { CharImage.SetSubRect(sf::IntRect(0, 16 ,16, 32));} // Dirty fix for printing 0 (zero) - why????
	CharImage.SetPosition(topX+((x-1)*16), topY+((y-1)*16)+((y-1)*2)); // was y*2 (y-1)*2)

	App.Draw(CharImage);
}

void drawText(int x, int y, std::string text)
{
	int strlen = text.size();
	for(int i = 0; i < strlen; ++i)
    {
		char current_char = text.at(i);
		int char_no = (int(current_char));
	
			DrawChar(16, x,y, char_no);
			x++;
		
	}
}



void bText(int x, int y, std::string text)
{
	int strlen = text.size();
	for(int i = 0; i < strlen; ++i)
    {
		char current_char = text.at(i);
		int char_no = (int(current_char));
		

			DrawChar(16, x,17+y, char_no); 
			x++;

	}
}


void drawText(int x, int y, int number)
{
	std::string text;
	std::stringstream out;
	out << number;
	text = out.str();
	

	int strlen = text.size();
	for(int i = 0; i < strlen; ++i)
    {
		char current_char = text.at(i);
		int char_no = (int(current_char));
		
	
			DrawChar(16, x,y, char_no);
			x++;
	
	}
}

void bText(int x, int y, int number)
{
	std::string text;
	std::stringstream out;
	out << number;
	text = out.str();

	int strlen = text.size();
	for(int i = 0; i < strlen; ++i)
    {
		char current_char = text.at(i);
		int char_no = (int(current_char));
		
			DrawChar(16, x,17+y, char_no);
			x++;
	
	}
}


void cText(std::string str)
{
	
		int string_length, current_string_length;
      int x;
      int y;
      int char_count;
	  std::string current_string;
	  std::string current_char;
      
      string_length = str.size(); 
      char_count = 0;
      current_string="";
      y = 2;
      while (char_count <= string_length)
      {
          current_char = str.substr(char_count,1);; //stringa[char_count];  
       
          if ((char_count==string_length) || (current_char=="@"))
          {
               current_string_length = current_string.size();
               x = ((40-current_string_length)/2)+1;
            
               
               
               drawText((x),(17+y),current_string);
           

               y++;
               char_count++;
               current_string="";                    
          }
          else
          {
               current_string = current_string+current_char;
               char_count++;              
          }         
       }
	   
}

void cyText(int y, std::string str)
{
	
		int string_length, current_string_length;
      int x;
      //int y;
      int char_count;
	  std::string current_string;
	  std::string current_char;
      
      string_length = str.size(); 
      char_count = 0;
      current_string="";
      //y = 2;
      while (char_count <= string_length)
      {
          current_char = str.substr(char_count,1);; //stringa[char_count];  
       
          if ((char_count==string_length) || (current_char=="@"))
          {
               current_string_length = current_string.size();
               x = ((40-current_string_length)/2)+1;
            
               
               
               drawText((x),(17+y),current_string);
           

               y++;
               char_count++;
               current_string="";                    
          }
          else
          {
               current_string = current_string+current_char;
               char_count++;              
          }         
       }
	   
}
