
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>

#include <string>
#include <iostream>
#include <sstream>

#include "player.h"
#include "font.h"
#include "display.h"
#include "explore.h"
#include "misc.h"
#include "guild.h"

//extern string mess[25];
//extern string room_descriptions[203];
//extern Mapcell levelmap[4096];
extern Player plyr;
//extern Teleport teleports[32];
extern sf::RenderWindow App;
sf::Music Music1;

struct guild
{
       string name;
       int x;
       int y;
       int z;
	   int removeCursesCost;
};


guild guilds[12] =
{
	{"Thieves Guild",			44,	30,	0,	9000},
	{"Blue Wizards Guild",		19,	17,	0,	3000},
	{"Light Wizards Guild",		3,	60,	0,	2700},
	{"Green Wizards Academy",	12,	22,	0,	3000},
	{"Red Wizards University",	48,	50,	0,	3000},
	{"Dark Wizards Guild",		34,	43,	0,	3100},
	{"Star Wizards Guild",		28,	53,	0,	2000},
	{"Wizards of Chaos Guild",	51,	5,	0,	4000},
	{"Wizards of Law Guild",	62,	15,	0,	3800},
	{"Guild of Order",			58,	15,	0,	4000},
	{"Physicians Guild",		6,	50,	0,	7000},
	{"Assassins Guild",			56,	62,	0,	11000}
};

/*
  Thieves Guild              43E, 34N        Skill                  9,000
  Blue Wizards Guild         18E, 47N        Physical Speed         3,000
  Light Wizards Guild        2E,  4N         Wisdom                 2,700
  Green Wizards Academy      11E, 42N        Stamina                3,000
  Red Wizards University     47E, 14N        Strength               3,000
  Dark Wizards Guild         33E, 21N        Charisma               3,100
  Star Wizards Guild         27E, 11N        Hit Points + Strength  2,000
  Wizards of Chaos Guild     50E, 59N        Charisma               4,000
  Wizards of Law Guild       61E, 49N        Wisdom                 3,800
  Guild of Order             57E, 49N        Intelligence           4,000
  Physicians Guild           5E,  14N        Hit Points             7,000
  Assassins Guild            55E,  2N        Suprise Attacks        11,000

  Mercenary Guild            32E, 55N        Strength               12,000
  Power Wizard Institute     25E, 44N        Stamina                2,500
*/


/*
guild guilds[6] =
{
    {"Wizards of Chaos Guild",51,5,2,1,2},
    {"Guild of Order",59,15,2,2,1},
    {"Wizards of Law Guild",63,15,2,2,4},
    {"Thieves' Guild",45,31,2,1,3},
    {"Dark Wizards Guild",34,43,2,1,6},
    {"Light Wizards Guild",3,60,2,2,5},
};
*/


inline std::string concat( int n, const char* str )
{
std::ostringstream ss;
ss << n;
ss << str;
return ss.str();
} 



void shopGuild()
{	
	int guildNo = getGuildNo();
	
	bool musicPlaying = false;
	int guildMenu = 1; // high level menu
	string str,key;
	plyr.status = 2; // shopping

	while (guildMenu > 0)
	{		
		while (guildMenu == 1) // main menu
		{
			drawShopImage("imgCityGuild");
			drawStatsPanel();
			

			//if (!musicPlaying) { Music1.Play(); musicPlaying = true; }
			
			if (plyr.guildAwards[guildNo] == false)
			{
				drawShopImage("imgCityGuild");
				drawStatsPanel();
				
				std::ostringstream text;
if (guildNo == 0) 
{text << "Master Thieves show you techniques@that improve your skill."; plyr.skl++; }
if (guildNo == 1) 
{plyr.speed++; text << "A Mage from The Guild of Blue@Wizards uses special magic to@increaseyour physical speed to " << plyr.speed << "."; }
if (guildNo == 2) 
{plyr.wis++; text << "A Mage from The Guild of Light@Wizards uses special magic to@increase your wisdom to " << plyr.wis << "."; }
if (guildNo == 3) 
{plyr.sta++; text << "A Mage from The Academy of Green@Wizards uses special magic to@increase your Stamina to " << plyr.sta << "."; }
if (guildNo == 4) 
{plyr.str++; text << "A Mage from The University of Red@Wizards uses special magic to@increase your Strength to " << plyr.str << "."; }
if (guildNo == 5) 
{plyr.chr++; text << "A Mage from The Guild of Dark Wizards@uses special magic to increase@your Charm to " << plyr.chr << "."; }
if (guildNo == 6) 
{text << "An Arch Mage from The Guild of Star@Wizards uses special magic to increase@your Hit Points and Strength."; plyr.str++; plyr.maxhp+=5; plyr.hp+=5; }
if (guildNo == 7) 
{plyr.chr++; text << "A Mage from The Guild of Chaos@uses special magic to increase@your Charm to " << plyr.chr << ".";  }
if (guildNo == 8) 
{plyr.wis++; text << "A Mage from The Guild of Law uses@special magic to increase@your wisdom to " << plyr.wis << "."; }
if (guildNo == 9) 
{plyr.inte++; text << "A Mage from The Guild of Order uses@special magic to increase your@Intelligence to " << plyr.inte << "."; }
if (guildNo == 10) 
{plyr.hp+=3; plyr.maxhp+=3; text << "A Doctor from The Guild of Physicians@teaches you First Aid beyond what@is commonly known. This increases@your Hit Points.";  }
if (guildNo == 11) 
{text << "A Master Assassin shows you some basic@forms of hiding and quiet approach@which increase your ability to@surprise attackers."; plyr.stealth+=30; }

					
				
				cText (text.str());
				cyText (9,"( Press a key )");
				App.Display();
				if (!musicPlaying) { Music1.OpenFromFile("data/audio/cityGuild.ogg"); Music1.Play(); musicPlaying = true; }

				key = pressKey();
				plyr.guildAwards[guildNo] = true;
			}

			drawShopImage("imgCityGuild");
			drawStatsPanel();
			
			bText (5,0, "You are at the Guild's entrance");
			//bText (2,0, guildNo);
			bText (13,1, "Do you wish to");
			bText (8,3, " ) Have all curses removed");
			bText (8,4, " ) Join our guild");
			bText (8,5, " ) Leave");
			SetFontColour(40, 96, 244, 255);
			bText (8,3, "1");
			bText (8,4, "2");
			bText (8,5, "0");
			SetFontColour(255, 255, 255, 255);
			str = "Your coins in copper " + itos(plyr.copper);
			cyText (9,str);
			App.Display();
			if (!musicPlaying) { Music1.Play(); musicPlaying = true; }
			

			key = pressKey();
			if ( key=="0" ) { guildMenu = 0; }
			if ( key=="1" ) { guildMenu = 2; }
			if ( key=="2" ) { guildMenu = 3; }
		}

		while (guildMenu == 2) // remove curses menu
		{
			int removeCursesCost = guilds[guildNo].removeCursesCost;
			drawShopImage("imgCityGuild");
			drawStatsPanel();
					
			cyText (0, "The charge for removing curses"); //itos(removeCursesCost) 
			std::ostringstream text;
			text << "is " << removeCursesCost << " coppers. Agreed?";		
			cyText (1,text.str());
			text.str("");
			//cyText (3, "Yes or No");	
			cyText (3,"( es or  o)");
			SetFontColour(40, 96, 244, 255);
			cyText (3," Y      N  ");
			SetFontColour(255, 255, 255, 255);

			str = "Your coins in copper " + itos(plyr.copper);
			cyText (9,str);
			
			App.Display();

			key = pressKey();
			if ( key=="N" ) { guildMenu = 1; }
			if ( key=="Y" ) { guildMenu = 4; }
		}

		while (guildMenu == 3) // Join guild menu
		{
			drawShopImage("imgCityGuild");
			drawStatsPanel();
			
			cText ("We are deeply sorry but we cannot@accept any apprentices at this time.");
			cyText (9,"( Press a key )");
			App.Display();

			key = pressKey();
			if ( key!="" ) { guildMenu = 1; }
		}

		while (guildMenu == 4) // Check funds and display sleeping time choices
		{
			int removeCursesCost = guilds[guildNo].removeCursesCost;
			
			drawShopImage("imgCityGuild");
			drawStatsPanel();
			//roomCost = Rooms[roomChoice].baseCost * Inns[InnNo].costMultiplier;
			bool cursesRemoved = false;
			if (removeCursesCost > plyr.copper)
			{
				cText ("I'm sorry, you have not the funds.");
			}
			else
			{
				cText ("Your curses are removed.");
				cursesRemoved = true;
			}
			cyText (9,"( Press a key )");
			App.Display();
			key = getSingleKey();
			if ( key!="" ) { if (cursesRemoved) { plyr.copper-=removeCursesCost; } guildMenu = 1; }
		}
		

	}
	Music1.Stop();
	leaveShop();
}

int getGuildNo()
{
int guild_no; 
for (int i=0 ; i<=12 ; i++) // Max number of guild objects
	{
		if ((guilds[i].x == plyr.x) && (guilds[i].y == plyr.y))
		{
			guild_no = i; // The number of the guild you have entered
        }
   } 

return guild_no;
}