
#include <SFML/Graphics.hpp>
#include <SFML/Audio.hpp>

#include <string>
#include <iostream>
#include <sstream>

#include "player.h"
#include "font.h"
#include "display.h"
#include "explore.h"
#include "misc.h"
#include "healer.h"

extern Player plyr;
extern sf::RenderWindow App;
sf::Music healerMusic;

/*
struct healer
{
       string name;
       int x;
       int y;
       int z;
	   int removeCursesCost;
};


healer healers[12] =
{
	{"Thieves healer",			44,	30,	0,	9000},
	{"Blue Wizards healer",		19,	17,	0,	3000},
	{"Light Wizards healer",		3,	60,	0,	2700},
	{"Green Wizards Academy",	12,	22,	0,	3000},
	{"Red Wizards University",	48,	50,	0,	3000},
	{"Dark Wizards healer",		34,	43,	0,	3100},
	{"Star Wizards healer",		28,	53,	0,	2000},
	{"Wizards of Chaos healer",	51,	5,	0,	4000},
	{"Wizards of Law healer",	62,	15,	0,	3800},
	{"healer of Order",			58,	15,	0,	4000},
	{"Physicians healer",		6,	50,	0,	7000},
	{"Assassins healer",			56,	62,	0,	11000}
};

*/



inline std::string concat( int n, const char* str )
{
std::ostringstream ss;
ss << n;
ss << str;
return ss.str();
} 

/*
string itos(int i)	// convert int to string
{
	stringstream s;
	s << i;
	return s.str();
}
*/


void shopHealer()
{	
	//int healerNo = gethealerNo();
	int healerMenu = 1; // high level menu
	string str,key;
	plyr.status = 2; // shopping

	while (healerMenu > 0)
	{		
		while (healerMenu == 1) // main menu
		{
			drawShopImage("imgCityHealer");
			drawStatsPanel();
			

			cyText (0, "Welcome Stranger!");
			cyText (1, "How may I serve you?");
			bText (15,3, " ) Heal");
			bText (15,4, " ) Cleanse");
			bText (15,5, " ) Restore");
			bText (15,6, " ) Diagnose");
			bText (15,7, " ) Leave");
			SetFontColour(40, 96, 244, 255);
			bText (15,3, "1");
			bText (15,4, "2");
			bText (15,5, "3");
			bText (15,6, "4");
			bText (15,7, "0");
			SetFontColour(255, 255, 255, 255);
			str = "Your coins in copper " + itos(plyr.copper);
			App.Display();

			key = pressKey();

			//if ( key=="1" ) { healerMenu = 2; }
			if ( key=="0" ) { healerMenu = 0; }
		}

		while (healerMenu == 2) // at bar, table or booth menu
		{
			drawShopImage("imgCityhealer");
			drawStatsPanel();
			
			bText (7,4, "1) Hail the Barkeeper");
			bText (7,5, "2) Hail the Waitress");
			bText (7,6, "3) Buy a round for the house");
			bText (7,7, "0) Leave");
			cyText (9, "Your coins in copper 255");
			App.Display();

			key = pressKey();
			if ( key=="0" ) { healerMenu = 0; }

		
		}

		while (healerMenu == 3) // Join healer menu
		{
			
		}

	}
	healerMusic.Stop();
	leaveShop();
}

int getHealerNo()
{

int healer_no;
/*
for (int i=0 ; i<=12 ; i++) // Max number of healer objects
	{
		if ((healers[i].x == plyr.x) && (healers[i].y == plyr.y))
		{
			healer_no = i; // The number of the healer you have entered
        }
   } 
*/
return healer_no;
}