#include <string>

int getMapIndex(int x,int y);
//void transMapIndex (int idx);
//void updateViewWindow();

void initMaps();
void transMapIndex (int idx);
void setCurrentZone();
//int getZone(int x,int y);

void saveHumanReadableMap();
void loadMapData(int map);
void loadDescriptions(int map);
void loadMessages(int map);
void loadZoneData(int map);
void moveMapLevel();


struct Teleport
{
 int ref;
 int new_x;
 int new_y;
 int new_map;
 int new_facing;      
};


struct Mapcell
{
 int north;
 int south;
 int west;
 int east;     
 int location;
 int special;
};

struct zoneRect
{
 int y1;
 int x1;
 int y2;
 int x2;     
 int zoneRef;
};

struct Map
{
 std::string filename;
 int width;
 int height;
 std::string description;     
 int background;
};
