#include <string>

void runEncounter();
void SetTileImage(int tile_no);
void loadCityMonsters();
void loadCityWeapons();

void drawEncounterView();
void initMonster(int monsterNo);
void playerAttack(int attackType,float attackFactorBonus);
void displayMonsterDiag();
void opponentAttack();
void opponentDeath();
void playerCharm();
void playerTrick();
void playerHail();
void playerOffer();
void playerSwitchWeapons();
int opponentChooseWeapon();
int calculateWeaponDamage(int weaponNo, float attackFactor, int attacker);

double round(double d);

struct monster
{
	std::string name;
	std::string armorText;
	int behaviour; // evil, bad, neutral, good
	int alignment; 
	int stealth;        
	int baseStrength;        
	int randomStrength;
	int baseSkill;
	int randomSkill;
	int baseIntelligence;
	int randomIntelligence;
	int baseSpeed;
	int randomSpeed;
	int baseHP;        
	int randomHP;
	int image;
	int image2;
	
	int armorBlunt;
	int armorSharp;
	int armorEarth;
	int armorAir;
	int armorFire;
	int armorWater;
	int armorPower;
	int armorMental;
	int armorCleric;

	int treasurePotions;
	int treasureEquipment;
	int treasureCopper;
	int treasureSilver;
	int treasureGold;
	int treasureGems;
	int treasureJewels;

	int weapon1;
	int weapon2;
	int weapon3;
	int weapon4;
	int weapon5;
	int weapon6;
	int weapon1chance;
	int weapon2chance;
	int weapon3chance;
	int weapon4chance;
	int weapon5chance;
	int weapon6chance;
};


struct weapon
{
	std::string name;
	std::string desc;
	int type;
	int rollLevel; 
	int baseAntiparry; 
	int randomAntiparry;        
	int attackRolls;        
	int attackRollValue;
	int useStrength;
	int blunt;
	int sharp;
	int earth;
	int air;
	int fire;
	int water;
	int power;
	int mental;
	int cleric;
};