#include <SFML/Graphics.hpp>

#include <string>
#include <stdio.h>
#include <stdlib.h>

#include <fstream>
#include <iostream>
#include <sstream>

#include "display.h"

using namespace std;
//extern int game_done;

extern sf::RenderWindow App;

using std::ofstream;
using namespace std;



string readKey()
{
	string keyString;

   
		// Process events
		sf::Event Event;
		while (App.GetEvent(Event))
		{
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Left)) keyString="left";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::J)) keyString="left";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Right)) keyString="right";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::L)) keyString="right";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Up)) keyString="up";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::I)) keyString="up";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Down)) keyString="down";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::K)) keyString="down";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Num0)) keyString="0";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Comma)) keyString=",";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Period)) keyString=".";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Num1)) keyString="1";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Num2)) keyString="2";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Num3)) keyString="3";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Num4)) keyString="4";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Num5)) keyString="5";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Num6)) keyString="6";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Num7)) keyString="7";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Num8)) keyString="8";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Num9)) keyString="9";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Y)) keyString="Y";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::N)) keyString="N";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::D)) keyString="D"; // diag info
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::E)) keyString="E"; // force encounter
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::A)) keyString="A";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::B)) keyString="B";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::C)) keyString="C";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Q)) keyString="Q";
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Space)) keyString="SPACE";

			// Close window : exit
			if (Event.Type == sf::Event::Closed)
				keyString="QUIT";

			// Escape key : exit
			if ((Event.Type == sf::Event::KeyPressed) && (Event.Key.Code == sf::Key::Escape))
				keyString="QUIT";
		}

	return(keyString);

}

string pressKey()
{
	string key;
	key = "";
	while (  (key!="SPACE") && (key!="0") && (key!="1") && (key!="2") && (key!="3") && (key!="4") && (key!="5") && (key!="6") 
		&& (key!="N") && (key!="Y") && (key!="A") && (key!="B") && (key!="C") )
	{
		key = readKey();
	}
	return key;
}

string getSingleKey() // single pass for a key
{
	string key;
	//key = "NO_INPUT";
	key = readKey();
	
	return key;
}


int randn(int n)
 {
   int result;
   result = rand()%n;
   if (result == 0) { result = 1; }
   return result;
 }




int rollDice(int x, int y)
{
    int result = 0;
    if (x != 0)
    {
         int i = 1;
         while (i <= x)
         {
             int roll = randn(y);
             result = result + roll;
             i++;
         }
    }  
     return result;    
}
