#include <SFML/Graphics.hpp>

#include <string>
#include <stdio.h>
#include <stdlib.h>

#include <fstream>
#include <iostream>
#include <sstream>
#include "player.h"


using namespace std;

extern Player plyr;

void increaseExperience(int xpIncrease)
{
	plyr.xp+=xpIncrease;
	
	switch(plyr.level)
    {
        case 0: 
			if ((plyr.xp > 199) && (plyr.xp < 400)) { increaseLevel(); }
			break;
		case 1: 
			if ((plyr.xp > 399) && (plyr.xp < 800)) { increaseLevel(); }
            break;
        case 2: 
			if ((plyr.xp > 799) && (plyr.xp < 1600)) { increaseLevel(); }
            break;
        case 3: 
			if ((plyr.xp > 1599) && (plyr.xp < 3200)) { increaseLevel(); }
			break;
        case 4: 
			if ((plyr.xp > 3199) && (plyr.xp < 6400)) { increaseLevel(); }
			break; 
	}
}

void increaseLevel()
{
	plyr.level++;
	int hpIncrease= sf::Randomizer::Random(0, plyr.sta); 
	plyr.hp+=hpIncrease;
	plyr.maxhp+=hpIncrease;
}

void addHour()
{
	if (plyr.hours == 23)
	{
		plyr.hours = 0; // 12 midnight
		addDay();
	}
	else
	{
		plyr.hours++;
		// perform hourly actions / checks
	}
}


void addDay()
{
	if (plyr.days == 31)
	{
		plyr.days = 1; // first day of a new month
		addMonth();
	}
	else
	{
		plyr.days++;
		// perform daily actions / checks / shop changes
	}
}


void addMonth()
{
	if (plyr.months == 12)
	{
		plyr.months = 1; // first month of a new year
		addYear();
	}
	else
	{
		plyr.months++;
		// perform monthly actions - are there any? Weather changes?
	}
}


void addYear()
{
	plyr.years++;
	// perform yearly actions - bank interest?
}




std::string itos(int i)	// convert int to string
{
	std::stringstream s;
	s << i;
	return s.str();
}

